# Automatic noise parse python program for DMM noise measurement project
# http://xdevs.com/article/dmm_noise/ - Article with details
# &copy; xDevs.com 2015

import csv
import sys
import math
import glob
import os
from math import exp, expm1, sqrt
from datetime import datetime

with open('output.txt','wb') as o:
    print ("| Multimeter \t| Range\t\t| NPLC\t| \t\t\tCounts\t|    Sq.sum\t|  Average\t|    SD\t\t|    SD,uV\t|")
    o.write ("|Multimeter|Range|NPLC|Counts|Sq.sum|Average|SD|SD,uV|\r\n")
    for filename in glob.glob('*.csv'):
        i = open(filename, 'r')
        reader = csv.DictReader(i)
        setname = filename.split("_")
        sqsum = 0
        sum = 0
        sum2 = 0
        cnt = 1
        sdo = 0
        variance = 0
        avg = 0
        for row in reader:
            sum += float(row[setname[0]])
            sum2 += (float(row[setname[0]]) * float(row[setname[0]]))
            cnt += 1
            avg = sum / cnt
            sdo = math.sqrt( sum2 / cnt - pow(avg,2))
            
        print ("| %s \t\t| %s \t\t| %s \t|\t%d\t| %.8f\t| %E\t| %E\t|%8.3f\t|" % 
            (setname[0],
             setname[1].split("DCVOLT")[1],
             setname[2].split("NPLC")[1].split(".csv")[0],
             cnt,
             sum,
             avg,
             sdo,
             sdo*1E6      
            )
        )
        i.close()
        o.write ("|%s|%s|%s|%d|%.8f|%E|%E|%.4f|\r\n" % 
            (setname[0],
             setname[1].split("DCVOLT")[1],
             setname[2].split("NPLC")[1].split(".csv")[0],
             cnt,
             sqsum,
             avg,
             sdo,
             sdo*1E6  
            )
        )

